﻿# Здесь основные предустановки и функции безотносительные к игре.
# Он у меня кочует из проекта в проект и может быть свободно распространён.
init -10 python: 

##################### Системные установки #####################

    import os,pygame,math,sys,random
    import xml.etree.ElementTree as xmldb
    import cPickle as serializer
    
    # установка окна игры по центру
    # полезно если запускается не в полный экран
    os.environ['SDL_VIDEO_CENTERED'] = '1'
    
    sys.setdefaultencoding('utf-8')
    
    # лень писать заглавные
    true = True
    false = False
    none = None
    
    result = True

    # иногда может глючить при сохранении, тогда убрать коммент
    # config.use_cpickle = False

######################## Расположения ########################

    top = Position(xalign = 0.5,yalign=0)
    bottom = Position(xalign = 0.5,yalign=1.0)
    left = Position(xalign = 0.0,yalign=0.5)
    right = Position(xalign = 1.0,yalign=0.5)
    center = Position(xalign = 0.5,yalign=0.5)
    
    almost_top = Position(xalign = 0.5,yalign=0.1)
    almost_bottom = Position(xalign = 0.5,yalign=0.9)
    almost_left = Position(xalign = 0.1,yalign=0.5)
    almost_right = Position(xalign = 0.9,yalign=0.5)
    
    upright = Position(xalign = 1.0,yalign=0.0)
    upleft = Position(xalign = 0.0,yalign=0.0)
    downright = Position(xalign = 1.0,yalign=1.0)
    downleft = Position(xalign = 0.0,yalign=1.0)
    
    up_quarter_left = Position(xalign = 0.25,yalign=0.0)
    up_quarter_right = Position(xalign = 0.75,yalign=0.0)    
    down_quarter_left = Position(xalign = 0.25,yalign=1.0)
    down_quarter_right = Position(xalign = 0.75,yalign=1.0)
    
    center_up = Position(xalign = 0.5,yalign = 0.25)
    
########################## Изображения ##########################
    renpy.image('bg black',Solid((0,0,0,255)))
    renpy.image('bg blood',Solid((150,6,7,255)))
    # цвета определены в colors.rpy

##################### Автоассоциирование #####################
    
    # вызов производится "show <filename>" 
    # имя файла без расширения
    # for fname in os.listdir(config.gamedir + '/img/abstract'):
        # if fname.endswith(('.jpg','.png','.jpeg')):
            # tag = fname[:-4]
            # image =  'img/abstract/' + fname
            # renpy.image(tag,image)

##################### Остальное #####################
    
    def trans_fadein(t, st, at):
        t.zoom = min(1.0, 0.01 + st / 1.0)
        t.alpha = min(1.0, 0.01 + st / 1.0)
        return 0
    def trans_fadeout(d, st, at):
         d.alpha = max(0.0, 1.0 - st / 2.0)
         return 0

    def particle_burst(img, xs, ys, xrad=0.05, yrad=0.05, wave=13, cnt=10):
        for ii in range (wave):
            renpy.pause(0.1)
            for i in range(cnt):
                xd = renpy.random.random()
                if xd > xs + xrad:
                    xd = xs + xrad
                if xd < xs - xrad:
                    xd = xs - xrad
                    
                yd = renpy.random.random()
                if yd > ys + yrad:
                    yd = ys + yrad
                if yd < ys - yrad:
                    yd = ys - yrad
                speed = renpy.random.random()
                renpy.show(img,at_list=[Transform(function=trans_fadeout),Move((xs,ys,0.5,0.5),(xd,yd,0.5,0.5),speed)],tag='%d%d'%(i,ii))
        for ii in range (wave):
            for i in range(cnt): 
                renpy.transition(slow_dissolve)
                renpy.hide('%d%d'%(i,ii))
    
    # возвращает последовательнось например 1-2-3-2-1
    def arcrange(start,end,step=1):
        list = []
        
        for i in range(start,end+1):
            list.append(i)
        
        pos = len(list)
        
        for i in range(start,end):
            list.insert(pos,i)
        
        return list
     
    # округление
    def math_round(number):
        integer,fraction = math.modf(number)
        if fraction >= 0.5:
            integer = math.ceil(number)
        else:
            integer = math.floor(number)
        return int(integer)

    # получить знак числа
    def sign(number):
        if number > 0:
            return 1
        elif number < 0:
            return -1
        else:
            return 0
    
    # эта функция не делает ничего, совсем ничего...
    def do_nothing():
        pass
    
    def exist(path):
        return os.path.exists(os.path.join(config.gamedir,path))
    
    # боремся с целочисленным по умолчанию делением
    def divide(n1,n2):
        return float(n1)/float(n2)
    
    # бросок стогранной кости. value - шанс, max - грани
    # например if dice(60): означает вероятнось в 60% 
    def dice(value,max=100,show=true):
        number = random.randrange(0,max+1)
        if number <= value:
            result = True
        else:
            result = False
        if config.developer and show:
            notify(u"Выпало %d из %d, предел - %d, итог - %s."%(number,max,value,str(result)))
        return result
     
    # выбрать случайный вариант из предложенных
    def select(variants):
        result = random.choice(variants)
        if config.developer:
            notify(u"Выбрано '%s'."%str(result))
        return result
    
    # выяснить что за нафиг путём записи нужных сообщений в файл
    # хотя вообще-то wtf = Write To File, но пользоватьей приходится
    # когда думаешь WTF?! в другой расшифровке...
    def wtf(message,logfile="bughunt.txt",linebreak='\n'):
        file = open(os.path.join(config.gamedir,logfile),"wb")
        file.write(str(message)+linebreak)                
        file.close()
        
    def toSafeString(s):
        s = str(s)
        s = s.replace("[","<")
        s = s.replace("]",">")
        s = s.replace("{","<")
        s = s.replace("}",">")   
        return s  
        
    # обёртка над оповещалкой
    def notify(message,style=False):
        if config.developer:
            if style: 
                msg = "{=%s}%s"%(style,toSafeString(message))
                renpy.notify(u"%s"%msg) 
            else:
                renpy.notify(u"{size=+10}%s"%toSafeString(message))          
    
    # безопасный джамп
    # если метки нет, игра не вылетит а просто сообщит об этом
    def jump(labelname):
        if renpy.has_label(labelname):
            notify("jump %s"%labelname)
            renpy.jump(labelname)
        else:
            notify(u"Метки '%s' не существует."%labelname)  
     
    # анализ строк и превращение их целые, дробные, и логические значения
    def parse(string):
        try:
            value = int(string)
        except TypeError:
            value = string
        except AttributeError:
            value = string
        except ValueError:
            try:
                value = float(string)
            except ValueError:
                if string.lower() in ['true','yes','on']:
                    value = True
                if string.lower() in ['false','no','off','none']:
                    value = False
                else:
                    value = string
        return value
    
    # Первая часть работы с базами данных - автокласс
    # Универсальная структура данных
    class Structure(object):
        def __init__(self,namespace=None): 
            self.flags = []
            if namespace:
                for key in namespace:
                    self.set(key,namespace[key])
        def get(self,par): return self.__dict__[par]
        def namespace(self): return self.__dict__
        def has(self,par): return self.__dict__.has_key(par)
        def set(self,par,value): self.__dict__[par] = value
        def mod(self,par,value): self.__dict__[par] += value
        def flag(self,flag): return flag in self.flags
        def setflag(self,flag): 
            if flag not in self.flags:
                self.flags.append(flag)
        def delflag(self,flag): 
            if flag in self.flags:
                self.flags.remove(flag)
    
    # вторая часть движка для работы с базами
    # разбор файла и загрузка его в словарь
    # выловленный в инете скрипт разбора ини доработан
    # для работы ещё и с хмл 
    def dict_from_config_file(file, raw=false, vars=None): 
        result = dict()

        if file[-3:] == 'ini':
            """Convert an INI file to a dictionary""" #from cherrypy 
            inifile = ConfigParser() 
            inifile.read(renpy.loader.transfn(file))     # Parse config file 
         
            # Load INI file into a dict 
            for section in inifile.sections(): 
                result[section] = dict() 
                for option in inifile.options(section): 
                    v = inifile.get(section, option, raw, vars) 
                    result[section][option] = v
                    
        elif file[-3:] == 'xml':
            tree = xmldb.parse(renpy.loader.transfn(file)).getroot()
            for node in tree:
                if not node.attrib.has_key('id'): node.attrib['id'] = node.tag 
                result[node.attrib['id']] = node.attrib
                result[node.attrib['id']]['xml'] = node
        return result    
     
    # Третья часть движка для работы с базами
    # превращаем словари в объекты и обрабатываем значения
    # 'true','yes','on','false','no','off' - станут логическими
    # числа без точки - станут целыми
    # числа с точкой - станут дробными
    # строки - строками и останутся ))
    # за это отвечает функция parse() определённая ранее
    # Параметры:
    # dic - можно вставить в существующий словарь, или использовать новый
    # entity - класс который создавать, имненно ссылка на тип существующего класса
    # perform_init - выполнить метод "init" ( не __init__ ) после загрузки 
    def load_database(file,dic = None,entity = Structure,perform_init = False):
        db = dict_from_config_file(file)
        if not dic:
            dictionary = dict()
        else:
            dictionary = dic
        for entry in db:
            dictionary[entry] = entity()
            for key in db[entry]:
                dictionary[entry].__dict__[key] = parse(db[entry][key])
                dictionary[entry].id = entry 
        
        if perform_init: 
            for entry in dictionary:        
                dictionary[entry].init()

        return dictionary

    # покажет позицию курсора если вывести рисунок cursorPosition
    # show cursorPosition on bottom
    def cursorPositionFunction(st, at):
        x,y = pygame.mouse.get_pos()
        return Text("{size=+10}%d - %d"%(x,y)), .1
        
    def viewportPositionFunction(st, at):
        x,y = xscr.value,yscr.value
        return Text("{size=+10}%d - %d"%(x,y)), .1   
        
    def imagePositionFunction(st, at):
        global xpos,ypos
        x,y = pygame.mouse.get_pos()
        vpx,vpy = xscr.value,yscr.value
        x = x - (config.screen_width - vp_size_x) + vpx
        y = y + vpy
        xpos,ypos = int(x),int(y)
        return Text("{size=+10}%d - %d"%(x,y)), .1   
            
        vp_size_x,vp_size_y  

    def listdir(dir):
        return os.listdir(os.path.join(config.gamedir,dir))
        
    def vp_coords(x,y):
        vpx,vpy = int(xscr.value),int(yscr.value)
        # x = int(x) - (config.screen_width - vp_size_x) + vpx
        # y = int(y) + vpy
        x = x + (config.screen_width - vp_size_x) - vpx
        y = y - vpy
        return x,y
            
label _instant_exit: 
    $renpy.quit()
    
label _full_restart: 
    $renpy.full_restart()
 
# добавляет в нижний левый угол несколько полезных на стадии разаработки примочек
# X - мгновенный выход, в обход диалога подтверждения
# R - перекомпиляция игры
# также отображает текущие координаты курсора
screen debugTools:
    hbox:        
        xalign 0.0
        yalign 1.0
        button:
            text "X"
            action Quit(confirm=False)
        button:
            text "R"
            action ui.callsinnewcontext("_save_reload_game")
        
        
            
            
            
            
            
            
            
            
                        