﻿init python:        
                
    class OnViewportChange(Action):
        """
        Class for a 'changed' callback for a viewport whose scroll position is to be saved.
        When the viewport position changes, the __call__ function is run.
        """

        def __init__(self, viewport):
            self.viewport = viewport
            
        def __call__(self, value):
            
            # Save the viewport position in a persistent variable.
            if not persistent.viewport_positions:
                persistent.viewport_positions = dict()
            persistent.viewport_positions[self.viewport] = value
            renpy.restart_interaction()
        
    def initialize_adjustment(viewport):
        """
        Returns the yadjustment property for a viewport whose scroll position is to be saved.
        """
        
        # If this viewport has a saved value, load that value.
        # If not, start the viewport at position 0.
        if persistent.viewport_positions and persistent.viewport_positions.has_key(viewport):
            initial_value = persistent.viewport_positions[viewport]
        else:
            persistent.viewport_positions = {}
            persistent.viewport_positions[viewport] = 0
            initial_value = 0
            
        return ui.adjustment(value=initial_value, changed=OnViewportChange(viewport))

screen Keyboard_Listener:
    add(keyboard_listener)

init python:
    class KeyboardListener(renpy.Displayable):

        def __init__(self):

            renpy.Displayable.__init__(self)

        # This function listens for events.
        def event(self, ev, x, y, st):
            global coords,data,selected
            # We only care about keydown events.
            if ev.type != pygame.KEYDOWN:
                return
            # if store.gallery.note == 'full':
                # elif ev.key == pygame.K_DOWN:   
                    # value = persistent.viewport_positions['yscr']
                    # store.yscr.change(value+10)
            if selected:
                if ev.key == pygame.K_KP_PLUS:
                    data[selected].size += 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_KP_MINUS:
                    data[selected].size -= 1
                    renpy.restart_interaction()
                    
                elif ev.key == pygame.K_DOWN:   
                    data[selected].y += 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_LEFT:   
                    data[selected].x -= 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_RIGHT:   
                    data[selected].x += 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_UP:   
                    data[selected].y -= 1
                    renpy.restart_interaction()
                    
                elif ev.key == pygame.K_HOME:   
                    data[selected].width += 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_PAGEUP:   
                    data[selected].height += 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_END:   
                    data[selected].width -= 1
                    renpy.restart_interaction()
                elif ev.key == pygame.K_PAGEDOWN:   
                    data[selected].height -= 1
                    renpy.restart_interaction()
                    
            if ev.key == pygame.K_SPACE:   
                coords = xpos,ypos
                data.append(Structure())
                data[-1].set('x',xpos)
                data[-1].set('y',ypos)
                data[-1].set('height',100)
                data[-1].set('width',100)
                data[-1].set('text','')
                data[-1].set('font','fonts/Anime Ace v02.ttf')
                data[-1].set('size',16)
                selected = len(data) - 1
                renpy.restart_interaction()


            return

        # Return a small empty render, so we get events.
        def render(self, width, height, st, at):
            return renpy.Render(1, 1)


    # Create a KonamiListener to actually listen for the code.
    keyboard_listener = KeyboardListener()
    
